## qcoro 0.8.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18.4)
set(qcoro_VERSION 0.8.0)
set(qcoro_SOVERSION 0)
project(qcoro LANGUAGES CXX VERSION ${qcoro_VERSION})

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

include(GNUInstallDirs)
include(CTest)
include(FeatureSummary)

#-----------------------------------------------------------#
# Options
#-----------------------------------------------------------#

option(QCORO_BUILD_EXAMPLES "Build examples" ON)
add_feature_info(Examples QCORO_BUILD_EXAMPLES "Build examples")
option(QCORO_ENABLE_ASAN "Build with AddressSanitizer" OFF)
add_feature_info(Asan QCORO_ENABLE_ASAN "Build with AddressSanitizer")
option(QCORO_DISABLE_DEPRECATED_TASK_H "Disable deprecated task.h header" OFF)

if(WIN32 OR APPLE OR ANDROID)
    option(QCORO_WITH_QTDBUS "Build QtDBus support" OFF)
else()
    option(QCORO_WITH_QTDBUS "Build QtDBus support" ON)
endif()
add_feature_info(QtDBus QCORO_WITH_QTDBUS "Build QtDBus support")
option(QCORO_WITH_QTNETWORK "Build QtNetwork support" ON)
add_feature_info(QtNetwork QCORO_WITH_QTNETWORK "Build QtNetwork support")
option(QCORO_WITH_QTWEBSOCKETS "Build QtWebSockets support" ON)
add_feature_info(QtWebSockets QCORO_WITH_QTWEBSOCKETS "Build QtWebSockets support")
option(QCORO_WITH_QTQUICK "Build QtQuick support" ON)
add_feature_info(QtQuick QCORO_WITH_QTQUICK "Build QtQuick support")
option(QCORO_WITH_QML "Build QML integration features" ON)
add_feature_info(QtQml QCORO_WITH_QML "Build QML integration features")

#-----------------------------------------------------------#
# Dependencies
#-----------------------------------------------------------#

set(THREADS_PREFER_PTHREAD_FLAG TRUE)
find_package(Threads REQUIRED)

include(cmake/CheckAtomic.cmake)

set(REQUIRED_QT_COMPONENTS Core)
set(REQUIRED_QT5_COMPONENTS)
set(REQUIRED_QT6_COMPONENTS)
if (QCORO_WITH_QTDBUS)
    list(APPEND REQUIRED_QT_COMPONENTS DBus)
endif()
if (QCORO_WITH_QTNETWORK)
    list(APPEND REQUIRED_QT_COMPONENTS Network)
endif()
if (QCORO_WITH_QTWEBSOCKETS)
    list(APPEND REQUIRED_QT_COMPONENTS WebSockets)
endif()
if (QCORO_WITH_QTQUICK)
    list(APPEND REQUIRED_QT_COMPONENTS Quick QuickPrivate)
endif()
if (QCORO_WITH_QML)
    list(APPEND REQUIRED_QT_COMPONENTS Qml)
    # Qt6 needs access to private API
    list(APPEND REQUIRED_QT6_COMPONENTS QmlPrivate)
endif()
if (QCORO_BUILD_EXAMPLES)
    list(APPEND REQUIRED_QT_COMPONENTS Widgets Concurrent)
endif()
if (BUILD_TESTING)
    list(APPEND REQUIRED_QT_COMPONENTS Test Concurrent)
endif()

set(MIN_REQUIRED_QT5_VERSION "5.12")
set(MIN_REQUIRED_QT6_VERSION "6.2.0")

include(cmake/QCoroFindQt.cmake)
# Find Qt. If USE_QT_VERSION is not set, it will try to look for Qt6 first
# and fallback to Qt5 otherwise.
qcoro_find_qt(
    QT_VERSION "${USE_QT_VERSION}"
    COMPONENTS "${REQUIRED_QT_COMPONENTS}"
    QT5_COMPONENTS "${REQUIRED_QT5_COMPONENTS}"
    QT6_COMPONENTS "${REQUIRED_QT6_COMPONENTS}"
    FOUND_VER_VAR QT_VERSION_MAJOR
)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/config.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/config.h
)

#-----------------------------------------------------------#
# Compiler Settings
#-----------------------------------------------------------#

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_AUTOMOC ON)

if (MSVC)
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /W4 /WX")
    # Disable warning C5054: "operator '&': deprecated between enumerations of different types" caused by QtWidgets/qsizepolicy.h
    # Disable warning C4127: "conditional expression is constant" caused by QtCore/qiterable.h
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /wd5054 /wd4127")

    if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
        # Explicitly enable exceptions support for clang-cl (it's only enabled by CMake when targeting the Windows-MSVC platform,
        # see https://github.com/danvratil/qcoro/issues/90 for details)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /EHsc")
    endif()
else()
    # Only enable strict warnings in debug mode
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wall -Wextra -Werror -pedantic")
endif()

if (QCORO_ENABLE_ASAN)
    if (MSVC)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /INCREMENTAL:NO")
        if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address")
        else()
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /fsanitize=address")
        endif()
    else()
        if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS_EQUAL "11.0.0")
            # I tried my best, but there are crashes when combining asan and coroutines.
            message(WARNING "ASAN not supported for Clang<=11.0")
        else()
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fno-omit-frame-pointer -fsanitize-recover=address")
        endif()
    endif()
endif()

add_compile_definitions(
    QT_NO_CAST_FROM_ASCII
    QT_NO_CAST_TO_ASCII
    QT_NO_URL_CAST_FROM_STRING
    QT_NO_CAST_FROM_BYTEARRAY
    QT_USE_STRINGBUILDER
    QT_NO_NARROWING_CONVERSIONS_IN_CONNECT
    QT_NO_KEYWORDS
    QT_NO_FOREACH
)
if (NOT WIN32)
    # strict iterators on MSVC only work when Qt itself is also built with them,
    # which is not usually the case. Otherwise there are linking issues.
    add_compile_definitions(QT_STRICT_ITERATORS)
endif()

include(qcoro/QCoroMacros.cmake)
qcoro_enable_coroutines()

include(cmake/CodeCoverage.cmake)
add_code_coverage()
add_code_coverage_all_targets(EXCLUDE "${CMAKE_BINARY_DIR}" tests/utils/*)

#-----------------------------------------------------------#
# Definitions
#-----------------------------------------------------------#

set(QCORO_TARGET_PREFIX "QCoro${QT_VERSION_MAJOR}")
set(QCORO_INSTALL_INCLUDEDIR "${CMAKE_INSTALL_INCLUDEDIR}/qcoro${QT_VERSION_MAJOR}")

#-----------------------------------------------------------#
# Sources
#-----------------------------------------------------------#

set(QCORO_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
add_subdirectory(qcoro)
if (QCORO_BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()
if (BUILD_TESTING)
    add_subdirectory(tests)
endif()

#-----------------------------------------------------------#
# Installation
#-----------------------------------------------------------#

include(CMakePackageConfigHelpers)

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/config.h
    DESTINATION ${QCORO_INSTALL_INCLUDEDIR}/qcoro
    COMPONENT Devel
)

configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/QCoroConfig.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/QCoro${QT_VERSION_MAJOR}Config.cmake"
    INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/QCoro${QT_VERSION_MAJOR}"
    PATH_VARS CMAKE_INSTALL_INCLUDEDIR
)

write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/QCoro${QT_VERSION_MAJOR}ConfigVersion.cmake"
    VERSION ${qcoro_VERSION}
    COMPATIBILITY SameMajorVersion
)

install(
    FILES "${CMAKE_CURRENT_BINARY_DIR}/QCoro${QT_VERSION_MAJOR}Config.cmake"
          "${CMAKE_CURRENT_BINARY_DIR}/QCoro${QT_VERSION_MAJOR}ConfigVersion.cmake"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/QCoro${QT_VERSION_MAJOR}"
    COMPONENT Devel
)

#-----------------------------------------------------------#
# Summary
#-----------------------------------------------------------#

feature_summary(FATAL_ON_MISSING_REQUIRED_PACKAGES WHAT ALL)

=== requirements.txt ===
setuptools
wheel
pymdown-extensions~=9.9
pygments~=2.14
mkdocs
mkdocs-material
mkdocs-section-index
mkdocs-include-markdown-plugin
mkdocs-macros-plugin
mkdocs-blogging-plugin

=== qcoro/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021 Daniel Vrátil <dvratil@kde.org>
#
# SPDX-License-Identifier: MIT

# Custom includes
include(GenerateHeaders)
include(AddQCoroLibrary)

include(CMakePackageConfigHelpers)

add_qcoro_library(
    NAME Coro
    INTERFACE
    NO_CMAKE_CONFIG
    INCLUDEDIR Coro
    CAMELCASE_HEADERS
        QCoro
        QCoroAsyncGenerator
        QCoroFwd
        QCoroGenerator
        QCoroTask
    HEADERS
        concepts_p.h
        coroutine.h
        macros_p.h
        waitoperationbase_p.h
    QT_LINK_LIBRARIES
        INTERFACE Core
)

if (NOT QCORO_DISABLE_DEPRECATED_TASK_H)
    # Install Task conditionally
    generate_headers(
        task_cc_HEADERS
        HEADER_NAMES Task
        OUTPUT_DIR QCoro
        ORIGINAL_HEADERS_VAR task_lc_HEADERS
    )

    install(
        FILES ${task_lc_HEADERS}
        DESTINATION ${QCORO_INSTALL_INCLUDEDIR}/qcoro/
        COMPONENT Devel
    )
    install(
        FILES ${task_cc_HEADERS}
        DESTINATION ${QCORO_INSTALL_INCLUDEDIR}/QCoro/
        COMPONENT Devel
    )
endif()


# The QCoroCoroConfig includes the QCoroMacros.cmake so we can't
# use the standard file generated by add_qcoro_library.
configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/QCoroCoroConfig.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/QCoro${QT_VERSION_MAJOR}CoroConfig.cmake"
    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/QCoro${QT_VERSION_MAJOR}Coro
    PATH_VARS CMAKE_INSTALL_INCLUDEDIR
)

write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/QCoro${QT_VERSION_MAJOR}CoroConfigVersion.cmake"
    VERSION ${qcoro_VERSION}
    COMPATIBILITY SameMajorVersion
)

# Install the extra macros file
install(
    FILES "QCoroMacros.cmake"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${QCORO_TARGET_PREFIX}Coro/"
)

############################

add_subdirectory(core)

if (QCORO_WITH_QTDBUS)
    add_subdirectory(dbus)
endif()

if (QCORO_WITH_QTNETWORK)
    add_subdirectory(network)
endif()

if (QCORO_WITH_QTWEBSOCKETS)
    add_subdirectory(websockets)
endif()

if (QCORO_WITH_QTQUICK)
    add_subdirectory(quick)
endif()

if (QCORO_WITH_QML)
    add_subdirectory(qml)
endif()

=== tests/CMakeLists.txt ===
add_subdirectory(testlibs)

include(CMakeParseArguments)

function(_enable_supressions _name)
    function(_enable_supressions_file _filename)
        if (EXISTS "${_filename}")
            set_tests_properties(test-${_name} PROPERTIES
                ENVIRONMENT LSAN_OPTIONS=suppressions=${_filename}
            )
        endif()
    endfunction()

    _enable_supressions_file("${CMAKE_CURRENT_SOURCE_DIR}/${_name}-qt${QT_VERSION_MAJOR}-lsan.supp")
endfunction()

function(qcoro_add_test _name)
    set(options SKIP_ADD_TEST)
    set(oneValueArgs)
    set(multiValueAgs LINK_LIBRARIES)
    cmake_parse_arguments(TEST "${options}" "${oneValueArgs}" "${multiValueAgs}" ${ARGN})
    add_executable(test-${_name} ${_name}.cpp)
    target_link_libraries(
        test-${_name}
        PRIVATE
        qcoro_test
        QCoro${QT_VERSION_MAJOR}Core
        Qt${QT_VERSION_MAJOR}::Core
        Qt${QT_VERSION_MAJOR}::Test
        ${TEST_LINK_LIBRARIES}
        Threads::Threads
    )
    if (NOT TEST_SKIP_ADD_TEST)
        add_test(NAME test-${_name} COMMAND test-${_name})
        _enable_supressions(${_name})
    endif()

    target_code_coverage(test-${_name} AUTO ALL EXCLUDE "${CMAKE_BINARY_DIR}" "tests/testlibs/*")
endfunction()

function(qcoro_add_network_test _name)
    qcoro_add_test(${_name} ${ARGN})
    target_link_libraries(
        test-${_name}
        PRIVATE
        QCoro${QT_VERSION_MAJOR}Network
        Qt${QT_VERSION_MAJOR}::Network
    )
    if(NOT HAVE_CXX_ATOMICS_WITHOUT_LIB)
        target_link_libraries(test-${_name} PRIVATE atomic)
    endif()
endfunction()

function(qcoro_add_dbus_test _name)
    qcoro_add_test(${_name} ${ARGN} SKIP_ADD_TEST)
    add_dependencies(test-${_name} testdbusserver qcoro_test_dbus)
    target_link_libraries(
        test-${_name}
        PRIVATE
        QCoro${QT_VERSION_MAJOR}DBus
        qcoro_test_dbus
    )
    target_compile_definitions(test-${_name} PRIVATE TESTDBUSSERVER_EXECUTABLE=\"$<TARGET_FILE:testdbusserver>\")
    if (APPLE)
        # On MacOS dbus-launch doesn't work, so we rely on the session dbus running
        add_test(NAME test-${_name} COMMAND test-${_name})
    else()
        add_test(NAME test-${_name} COMMAND dbus-launch $<TARGET_FILE:test-${_name}>)
    endif()
    _enable_supressions(${_name})
endfunction()

function(qcoro_add_websockets_test _name)
    qcoro_add_network_test(${_name} ${ARGN})
    target_link_libraries(
        test-${_name}
        PRIVATE
        QCoro${QT_VERSION_MAJOR}WebSockets
        Qt${QT_VERSION_MAJOR}::WebSockets
        qcoro_test_ws
    )
endfunction()

function(qcoro_add_qml_test _name)
    qcoro_add_network_test(${_name} ${ARGN})
    target_link_libraries(
        test-${_name}
        PRIVATE
        QCoro${QT_VERSION_MAJOR}Qml
        Qt${QT_VERSION_MAJOR}::Qml
    )
endfunction()

function(qcoro_add_quick_test _name)
    qcoro_add_test(${_name} ${ARGN})
    target_link_libraries(
        test-${_name}
        PRIVATE
        QCoro${QT_VERSION_MAJOR}Quick
        Qt${QT_VERSION_MAJOR}::Quick
        Qt${QT_VERSION_MAJOR}::QuickPrivate
    )
    get_test_property(test-${_name} ENVIRONMENT _env)
    list(APPEND _env QT_QPA_PLATFORM=offscreen)
    set_tests_properties(test-${_name} PROPERTIES ENVIRONMENT "${_env}")
endfunction()

qcoro_add_test(qtimer)
qcoro_add_test(qcoroprocess)
qcoro_add_test(qcorosignal)
qcoro_add_test(qcorothread)
qcoro_add_test(qcorotask)
qcoro_add_test(testconstraints)
qcoro_add_test(qfuture LINK_LIBRARIES Qt${QT_VERSION_MAJOR}::Concurrent)
qcoro_add_test(qcorogenerator)
qcoro_add_test(qcoroasyncgenerator)

if (QCORO_WITH_QTDBUS)
    qcoro_add_dbus_test(qdbuspendingcall)
    qcoro_add_dbus_test(qdbuspendingreply)
endif()

if (QCORO_WITH_QTNETWORK)
    qcoro_add_network_test(qcorolocalsocket)
    qcoro_add_network_test(qcoroabstractsocket)
    qcoro_add_network_test(qcoronetworkreply)
    qcoro_add_network_test(qcorotcpserver)

    # Tests for test utilities
    qcoro_add_network_test(testhttpserver)
endif()

if (QCORO_WITH_QTWEBSOCKETS)
    qcoro_add_websockets_test(qcorowebsocket)
    qcoro_add_websockets_test(qcorowebsocketserver)
endif()

if (QCORO_WITH_QML)
    qcoro_add_qml_test(qcoroqmltask)
endif()

if (QCORO_WITH_QTQUICK)
    qcoro_add_quick_test(qcoroimageprovider)
endif()

=== examples/chained/CMakeLists.txt ===
add_executable(chained-example main.cpp)
target_link_libraries(chained-example
    QCoro${QT_VERSION_MAJOR}Core
    Qt${QT_VERSION_MAJOR}::Core
)

=== qcoro/core/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021 Daniel Vrátil <dvratil@kde.org>
#
# SPDX-License-Identifier: MIT

add_qcoro_library(
    NAME Core
    INCLUDEDIR Core
    SOURCES
        qcoroiodevice.cpp
        qcoroiodevice_p.cpp
        qcoroprocess.cpp
        qcorothread.cpp
        qcorotimer.cpp
    CAMELCASE_HEADERS
        QCoroCore
        QCoroIODevice
        QCoroProcess
        QCoroSignal
        QCoroThread
        QCoroTimer
        QCoroFuture
    QT_LINK_LIBRARIES
        PUBLIC Core
    QCORO_LINK_LIBRARIES
        PUBLIC Coro
)

=== tests/testlibs/CMakeLists.txt ===
add_library(qcoro_test
    STATIC
    testobject.cpp
    testloop.cpp
)
target_include_directories(qcoro_test PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(qcoro_test PUBLIC
    QCoro${QT_VERSION_MAJOR}Core
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Test
)

if (QCORO_WITH_QTDBUS)
    add_executable(testdbusserver EXCLUDE_FROM_ALL testdbusserver.cpp)
    target_link_libraries(testdbusserver
        Qt${QT_VERSION_MAJOR}::Core
        Qt${QT_VERSION_MAJOR}::DBus
    )

    set(qcoro_test_dbus_SRCS)
    if (${QT_VERSION_MAJOR} EQUAL 5)
        qt5_add_dbus_interface(qcoro_test_dbus_SRCS cz.dvratil.qcorodbustest.xml qcorodbustestinterface)
    else()
        qt_add_dbus_interface(qcoro_test_dbus_SRCS cz.dvratil.qcorodbustest.xml qcorodbustestinterface)
    endif()

    add_library(qcoro_test_dbus OBJECT ${qcoro_test_dbus_SRCS})
    target_include_directories(qcoro_test_dbus PUBLIC
        ${CMAKE_CURRENT_SOURCE_DIR}
        ${CMAKE_CURRENT_BINARY_DIR}
    )
    target_link_libraries(qcoro_test_dbus PUBLIC
        Qt${QT_VERSION_MAJOR}::Core
        Qt${QT_VERSION_MAJOR}::DBus
    )
endif()

if (QCORO_WITH_QTWEBSOCKETS)
    set(qcoro_test_ws_SRCS testwsserver.cpp)
    add_library(qcoro_test_ws OBJECT ${qcoro_test_ws_SRCS})
    target_include_directories(qcoro_test_ws PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
    target_link_libraries(qcoro_test_ws PUBLIC
        Qt${QT_VERSION_MAJOR}::Core
        Qt${QT_VERSION_MAJOR}::Test
        Qt${QT_VERSION_MAJOR}::WebSockets
    )
endif()

=== examples/dbus/common/CMakeLists.txt ===

# Build the dbus-server as a stand-alone executable to workaround QTBUG-92107
add_executable(dbusserver dbusserver.cpp)
set_target_properties(dbusserver
    PROPERTIES COMPILE_DEFINITIONS STANDALONE
)
target_link_libraries(dbusserver
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::DBus
)

#-----------------------------------------------------#

set(common_SRCS
    dbusserver.cpp
)

add_library(examples-dbus-common STATIC ${common_SRCS})
set_target_properties(examples-dbus-common PROPERTIES COMPILE_DEFINITIONS SERVER_EXEC_PATH=\"$<TARGET_FILE:dbusserver>\")
target_include_directories(examples-dbus-common
    INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/..>
)
target_link_libraries(examples-dbus-common
    PUBLIC
    Qt${QT_VERSION_MAJOR}::Core
    PRIVATE
    Qt${QT_VERSION_MAJOR}::DBus
)

=== debian/changelog ===
qcoro (0.8.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update standards version to 4.6.2, no changes needed.
  * Update symbols files.
  * Update lintian overrides.

 -- Pino Toscano <pino@debian.org>  Wed, 01 Feb 2023 23:16:33 +0100

qcoro (0.7.0-4) unstable; urgency=medium

  [ Rik Mills ]
  * debian/rules: Set option to disable building with LTO. Allows
    syncing direct to Ubuntu with current symbols files.

  [ Sandro Knauß ]
  * Update symbols against new Qt 6.4.2 (Closes: #1027505).

 -- Sandro Knauß <hefee@debian.org>  Wed, 04 Jan 2023 10:57:15 +0100

qcoro (0.7.0-3) unstable; urgency=medium

  [ Sandro Knauß ]
  * Upload a new source-only version so it can migrate to testing.

 -- Sandro Knauß <hefee@debian.org>  Wed, 30 Nov 2022 09:02:30 +0100

qcoro (0.7.0-2) unstable; urgency=medium

  [ Sandro Knauß ]
  * Build QML and QtQuick libs.
  * Add B-D to run QML and QtQuick tests.
  * Add new packages for QML and QtQuick.

 -- Sandro Knauß <hefee@debian.org>  Sun, 27 Nov 2022 22:06:11 +0100

qcoro (0.7.0-1) unstable; urgency=medium

  [ Sandro Knauß ]
  * New upstream release (0.7.0).
  * Remove upstream applied patches.
  * Don't build QML and QtQuick libs for the moment.
  * Update symbols for new version.

 -- Sandro Knauß <hefee@debian.org>  Sun, 27 Nov 2022 16:03:17 +0100

qcoro (0.6.0-5) unstable; urgency=medium

  [ Sandro Knauß ]
  * d/watch: track versions on github correctly.

 -- Sandro Knauß <hefee@debian.org>  Sat, 24 Sep 2022 15:13:33 +0200

## qcoro 0.9.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.18.4)
-set(qcoro_VERSION 0.8.0)
+set(qcoro_VERSION 0.9.0)
 set(qcoro_SOVERSION 0)
 project(qcoro LANGUAGES CXX VERSION ${qcoro_VERSION})
 
@@ -33,6 +33,8 @@
 add_feature_info(QtQuick QCORO_WITH_QTQUICK "Build QtQuick support")
 option(QCORO_WITH_QML "Build QML integration features" ON)
 add_feature_info(QtQml QCORO_WITH_QML "Build QML integration features")
+option(QCORO_WITH_QTTEST "Build QtTest support" ON)
+add_feature_info(QtTest QCORO_WITH_QTTEST "Build QtTest support")
 
 #-----------------------------------------------------------#
 # Dependencies
@@ -62,6 +64,9 @@
     list(APPEND REQUIRED_QT_COMPONENTS Qml)
     # Qt6 needs access to private API
     list(APPEND REQUIRED_QT6_COMPONENTS QmlPrivate)
+endif()
+if (QCORO_WITH_QTTEST)
+    list(APPEND REQUIRED_QT_COMPONENTS Test)
 endif()
 if (QCORO_BUILD_EXAMPLES)
     list(APPEND REQUIRED_QT_COMPONENTS Widgets Concurrent)

=== requirements.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 setuptools
 wheel
-pymdown-extensions~=9.9
-pygments~=2.14
+pymdown-extensions~=9.11
+pygments~=2.15
 mkdocs
 mkdocs-material
 mkdocs-section-index

=== qcoro/CMakeLists.txt ===
--- 
+++ 
@@ -94,3 +94,7 @@
 if (QCORO_WITH_QML)
     add_subdirectory(qml)
 endif()
+
+if (QCORO_WITH_QTTEST)
+    add_subdirectory(test)
+endif()

=== debian/changelog ===
qcoro (0.9.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update symbols files.

 -- Pino Toscano <pino@debian.org>  Fri, 16 Jun 2023 07:09:47 +0200

## qcoro 0.10.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.18.4)
-set(qcoro_VERSION 0.9.0)
+set(qcoro_VERSION 0.10.0)
 set(qcoro_SOVERSION 0)
 project(qcoro LANGUAGES CXX VERSION ${qcoro_VERSION})
 
@@ -105,7 +105,10 @@
     set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /W4 /WX")
     # Disable warning C5054: "operator '&': deprecated between enumerations of different types" caused by QtWidgets/qsizepolicy.h
     # Disable warning C4127: "conditional expression is constant" caused by QtCore/qiterable.h
-    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /wd5054 /wd4127")
+    if ("${QT_VERSION_MAJOR}" STREQUAL "6" AND "${Qt6_VERSION}" VERSION_GREATER_EQUAL "6.4.0" AND "${Qt6_VERSION}" VERSION_LESS "6.5.3")
+        # Disable warning C4702: "unreachable code" caused by QtTest/qtestcase.h - fixed in Qt 6.5.3
+        set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /wd5054 /wd4127 /wd4702")
+    endif()
 
     if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
         # Explicitly enable exceptions support for clang-cl (it's only enabled by CMake when targeting the Windows-MSVC platform,
@@ -120,6 +123,7 @@
 if (QCORO_ENABLE_ASAN)
     if (MSVC)
         set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /INCREMENTAL:NO")
+        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /INCREMENTAL:NO")
         if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
             set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address")
         else()
@@ -162,6 +166,15 @@
 # Definitions
 #-----------------------------------------------------------#
 
+# debug suffixes for qmake compatibility
+if(WIN32)
+    set(CMAKE_DEBUG_POSTFIX "d")
+elseif(APPLE)
+    set(CMAKE_DEBUG_POSTFIX "_debug")
+else()
+    set(CMAKE_DEBUG_POSTFIX "")
+endif()
+
 set(QCORO_TARGET_PREFIX "QCoro${QT_VERSION_MAJOR}")
 set(QCORO_INSTALL_INCLUDEDIR "${CMAKE_INSTALL_INCLUDEDIR}/qcoro${QT_VERSION_MAJOR}")

=== requirements.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 setuptools
 wheel
-pymdown-extensions~=9.11
-pygments~=2.15
+pymdown-extensions~=10.5
+pygments~=2.17
 mkdocs
 mkdocs-material
 mkdocs-section-index

=== examples/CMakeLists.txt ===
add_subdirectory(basics)
if (QCORO_WITH_QTDBUS)
    add_subdirectory(dbus)
endif()
if (QCORO_WITH_QTNETWORK)
    add_subdirectory(network)
endif()
if (QCORO_QT_HAS_COMPAT_ABI)
    add_subdirectory(future)
endif()
add_subdirectory(iodevice)
add_subdirectory(timer)
add_subdirectory(chained)

=== qcoro/CMakeLists.txt ===
--- 
+++ 
@@ -24,6 +24,13 @@
         coroutine.h
         macros_p.h
         waitoperationbase_p.h
+        impl/connect.h
+        impl/task.h
+        impl/taskawaiterbase.h
+        impl/taskfinalsuspend.h
+        impl/taskpromise.h
+        impl/taskpromisebase.h
+        impl/waitfor.h
     QT_LINK_LIBRARIES
         INTERFACE Core
 )

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -23,7 +23,7 @@
     target_link_libraries(
         test-${_name}
         PRIVATE
-        qcoro_test
+        qcoro_testlib
         QCoro${QT_VERSION_MAJOR}Core
         Qt${QT_VERSION_MAJOR}::Core
         Qt${QT_VERSION_MAJOR}::Test

=== examples/dbus/CMakeLists.txt ===
add_subdirectory(common)
add_subdirectory(regular-blocking)
add_subdirectory(coroutine)

=== qcoro/quick/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 Daniel Vrátil <dvratil@kde.org>
# SPDX-FileCopyrightText: 2022 Jonah Brüchert <jbb@kaidan.im>
#
# SPDX-License-Identifier: MIT

add_qcoro_library(
    NAME Quick
    SOURCES
        qcoroimageprovider.cpp
    CAMELCASE_HEADERS
        QCoroImageProvider
    QCORO_LINK_LIBRARIES
        PUBLIC Coro Core
    QT_LINK_LIBRARIES
    PUBLIC Core Quick
)

=== examples/dbus/coroutine/CMakeLists.txt ===
set(dbustest_SRCS
    main.cpp
)

add_executable(dbustest-coro ${dbustest_SRCS})
target_link_libraries(dbustest-coro
    QCoro${QT_VERSION_MAJOR}DBus
    examples-dbus-common
    Threads::Threads
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::DBus
)

=== examples/dbus/regular-blocking/CMakeLists.txt ===
set(dbustest_SRCS
    main.cpp
)

add_executable(dbustest ${dbustest_SRCS})
target_link_libraries(dbustest
    examples-dbus-common
    Threads::Threads
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::DBus
)

=== debian/changelog ===
qcoro (0.10.0-1.1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:43:17 +1100

qcoro (0.10.0-1.1build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 06:37:17 +0000

qcoro (0.10.0-1.1build1) noble; urgency=medium

  * No-change rebuild against libqt6core6t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 12 Mar 2024 01:56:11 +0000

qcoro (0.10.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062712

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 21:33:56 +0000

qcoro (0.10.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update symbols files.

 -- Pino Toscano <pino@debian.org>  Wed, 06 Dec 2023 22:35:12 +0100

=== debian/control ===
Source: qcoro
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Sandro Knauß <hefee@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5), cmake (>= 3.18.4~),
               dbus-x11 <!nocheck>,
               debhelper-compat (= 13),
               libqt5websockets5-dev (>= 5.15.0~),
               libqt6opengl6-dev,
               libqt6websockets6-dev (>= 6.2.0~),
               pkg-kde-tools,
               qml-module-qtquick-controls <!nocheck>,
               qml6-module-qtqml-workerscript <!nocheck>,
               qml6-module-qtquick <!nocheck>,
               qt6-base-dev (>= 6.2.0~),
               qt6-base-private-dev,
               qt6-declarative-dev,
               qt6-declarative-private-dev,
               qtbase5-dev (>= 5.15.0~),
               qtbase5-private-dev,
               qtdeclarative5-dev,
               qtdeclarative5-private-dev,
               xauth <!nocheck>,
               xvfb <!nocheck>
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/qcoro
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/qcoro.git
Homepage: https://qcoro.dvratil.cz/
Rules-Requires-Root: no

Package: libqcoro5core0t64
Provides: ${t64:Provides}
Replaces: libqcoro5core0
Breaks: libqcoro5core0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt5 - Core
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt5 actions.
 .
 This is the core library.

Package: libqcoro6core0t64
Provides: ${t64:Provides}
Replaces: libqcoro6core0
Breaks: libqcoro6core0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt6 - Core
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt6 actions.
 .
 This is the core library.

Package: libqcoro5dbus0t64
Provides: ${t64:Provides}
Replaces: libqcoro5dbus0
Breaks: libqcoro5dbus0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt5 - DBus
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt5 actions.
 .
 This is the DBus library.

Package: libqcoro6dbus0t64
Provides: ${t64:Provides}
Replaces: libqcoro6dbus0
Breaks: libqcoro6dbus0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt6 - DBus
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt6 actions.
 .
 This is the DBus library.

Package: libqcoro5network0t64
Provides: ${t64:Provides}
Replaces: libqcoro5network0
Breaks: libqcoro5network0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt5 - Network
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt5 actions.
 .
 This is the network library.

Package: libqcoro6network0t64
Provides: ${t64:Provides}
Replaces: libqcoro6network0
Breaks: libqcoro6network0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt6 - Network
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt6 actions.
 .
 This is the network library.

Package: libqcoro5qml0t64
Provides: ${t64:Provides}
Replaces: libqcoro5qml0
Breaks: libqcoro5qml0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt5 - QML
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt5 actions.
 .
 This is the QML library.

Package: libqcoro6qml0t64
Provides: ${t64:Provides}
Replaces: libqcoro6qml0
Breaks: libqcoro6qml0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt6 - QML
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt6 actions.
 .
 This is the QML library.

Package: libqcoro5quick0t64
Provides: ${t64:Provides}
Replaces: libqcoro5quick0
Breaks: libqcoro5quick0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt5 - QtQuick
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt5 actions.
 .
 This is the QtQuick library.

Package: libqcoro6quick0t64
Provides: ${t64:Provides}
Replaces: libqcoro6quick0
Breaks: libqcoro6quick0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt6 - QtQuick
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt6 actions.
 .
 This is the QtQuick library.

Package: libqcoro5websockets0t64
Provides: ${t64:Provides}
Replaces: libqcoro5websockets0
Breaks: libqcoro5websockets0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt5 - WebSockets
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt5 actions.
 .
 This is the web sockets library.

Package: libqcoro6websockets0t64
Provides: ${t64:Provides}
Replaces: libqcoro6websockets0
Breaks: libqcoro6websockets0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt6 - WebSockets
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt6 actions.
 .
 This is the web sockets library.

Package: qcoro-doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Section: doc
Description: C++20 coroutines for Qt5 - documentation & examples
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt actions.
 .
 This package has the examples and documentation files.

Package: qcoro-qt5-dev
Architecture: any
Multi-Arch: same
Depends: libqcoro5core0t64 (= ${binary:Version}),
         libqcoro5dbus0t64 (= ${binary:Version}),
         libqcoro5network0t64 (= ${binary:Version}),
         libqcoro5qml0t64 (= ${binary:Version}),
         libqcoro5quick0t64 (= ${binary:Version}),
         libqcoro5websockets0t64 (= ${binary:Version}),
         libqt5websockets5-dev (>= 5.15.0~),
         qtbase5-dev (>= 5.15.0~),
         ${misc:Depends}
Recommends: qcoro-doc
Section: libdevel
Description: C++20 coroutines for Qt5 - development
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt5 actions.
 .
 This package has the development files.

Package: qcoro-qt6-dev
Architecture: any
Multi-Arch: same
Depends: libqcoro6core0t64 (= ${binary:Version}),
         libqcoro6dbus0t64 (= ${binary:Version}),
         libqcoro6network0t64 (= ${binary:Version}),
         libqcoro6qml0t64 (= ${binary:Version}),
         libqcoro6quick0t64 (= ${binary:Version}),
         libqcoro6websockets0t64 (= ${binary:Version}),
         libqt6websockets6-dev (>= 6.2.0~),
         qt6-base-dev (>= 6.2.0~),
         ${misc:Depends}
Recommends: qcoro-doc
Section: libdevel
Description: C++20 coroutines for Qt6 - development
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt6 actions.
 .
 This package has the development files.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto

CMAKE_ARGS = -DBUILD_SHARED_LIBS=ON -DQCORO_BUILD_EXAMPLES=OFF

%:
	dh $@ --with pkgkde_symbolshelper

execute_after_dh_auto_clean:
	rm -rf build-Qt6

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_ARGS) -DUSE_QT_VERSION=5
	dh_auto_configure --builddirectory=build-Qt6 -- $(CMAKE_ARGS) -DUSE_QT_VERSION=6

override_dh_auto_build:
	dh_auto_build
	dh_auto_build --builddirectory=build-Qt6

override_dh_auto_install:
	dh_auto_install
	dh_auto_install --builddirectory=build-Qt6

execute_after_dh_install-indep:
	rm debian/qcoro-doc/usr/share/doc/qcoro-doc/docs/changelog.md
	rm -r debian/qcoro-doc/usr/share/doc/qcoro-doc/docs/about
	rm -r debian/qcoro-doc/usr/share/doc/qcoro-doc/docs/overrides

override_dh_auto_test:
	xvfb-run -- dh_auto_test --no-parallel
	sleep 2 # we need to wait for the Xserver to shutdown
	xvfb-run -- dh_auto_test --no-parallel --builddirectory=build-Qt6

## qcoro 0.11.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.18.4)
-set(qcoro_VERSION 0.10.0)
+set(qcoro_VERSION 0.11.0)
 set(qcoro_SOVERSION 0)
 project(qcoro LANGUAGES CXX VERSION ${qcoro_VERSION})
 
@@ -13,8 +13,16 @@
 # Options
 #-----------------------------------------------------------#
 
+
+# Allow QCORO_BUILD_TESTING to override BUILD_TESTING, but default to BUILD_TESTING if not set
+if (DEFINED QCORO_BUILD_TESTING)
+    set(BUILD_TESTING ${QCORO_BUILD_TESTING})
+endif()
+
 option(QCORO_BUILD_EXAMPLES "Build examples" ON)
 add_feature_info(Examples QCORO_BUILD_EXAMPLES "Build examples")
+option(QCORO_BUILD_TESTING "Build QCoro tests" ${BUILD_TESTING})
+add_feature_info(Testing QCORO_BUILD_TESTING "Build QCoro tests")
 option(QCORO_ENABLE_ASAN "Build with AddressSanitizer" OFF)
 add_feature_info(Asan QCORO_ENABLE_ASAN "Build with AddressSanitizer")
 option(QCORO_DISABLE_DEPRECATED_TASK_H "Disable deprecated task.h header" OFF)
@@ -58,7 +66,7 @@
     list(APPEND REQUIRED_QT_COMPONENTS WebSockets)
 endif()
 if (QCORO_WITH_QTQUICK)
-    list(APPEND REQUIRED_QT_COMPONENTS Quick QuickPrivate)
+    list(APPEND REQUIRED_QT_COMPONENTS Gui Quick QuickPrivate)
 endif()
 if (QCORO_WITH_QML)
     list(APPEND REQUIRED_QT_COMPONENTS Qml)
@@ -118,6 +126,17 @@
 else()
     # Only enable strict warnings in debug mode
     set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wall -Wextra -Werror -pedantic")
+
+    if (ANDROID)
+        include(DetectAndroidNDKVersion)
+        detectAndroidNDKVersion(NDK_VERSION)
+        if ("${NDK_VERSION}" VERSION_LESS 26)
+            # Android NDK < 26 ships mismatching versions of clang and libc++ - libc++ is older and doesn't have coroutine support
+            # which forces us to use coroutines from std::experimental. But the clang itself is newer and emits an error about
+            # std::experimental coroutines being deprecated in LLVM 14. This option is needed to suppress the error.
+            add_compile_options(-Wno-error=deprecated-experimental-coroutine)
+        endif()
+    endif()
 endif()
 
 if (QCORO_ENABLE_ASAN)
@@ -130,12 +149,7 @@
             set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /fsanitize=address")
         endif()
     else()
-        if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS_EQUAL "11.0.0")
-            # I tried my best, but there are crashes when combining asan and coroutines.
-            message(WARNING "ASAN not supported for Clang<=11.0")
-        else()
-            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fno-omit-frame-pointer -fsanitize-recover=address")
-        endif()
+        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fno-omit-frame-pointer -fsanitize-recover=address")
     endif()
 endif()
 
@@ -187,7 +201,7 @@
 if (QCORO_BUILD_EXAMPLES)
     add_subdirectory(examples)
 endif()
-if (BUILD_TESTING)
+if (QCORO_BUILD_TESTING)
     add_subdirectory(tests)
 endif()

=== requirements.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 setuptools
 wheel
-pymdown-extensions~=10.5
-pygments~=2.17
+pymdown-extensions~=10.11
+pygments~=2.18
 mkdocs
 mkdocs-material
 mkdocs-section-index

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -11,3 +11,4 @@
 add_subdirectory(iodevice)
 add_subdirectory(timer)
 add_subdirectory(chained)
+add_subdirectory(background-task)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -110,10 +110,12 @@
 qcoro_add_test(qcorosignal)
 qcoro_add_test(qcorothread)
 qcoro_add_test(qcorotask)
+qcoro_add_test(qcorolazytask)
 qcoro_add_test(testconstraints)
 qcoro_add_test(qfuture LINK_LIBRARIES Qt${QT_VERSION_MAJOR}::Concurrent)
 qcoro_add_test(qcorogenerator)
 qcoro_add_test(qcoroasyncgenerator)
+qcoro_add_test(qcorowaitfor)
 
 if (QCORO_WITH_QTDBUS)
     qcoro_add_dbus_test(qdbuspendingcall)

=== examples/background-task/CMakeLists.txt ===
add_executable(background-task-example)
target_sources(background-task-example PRIVATE main.cpp)
target_link_libraries(background-task-example
    PRIVATE
    QCoro${QT_VERSION_MAJOR}Core
    Qt${QT_VERSION_MAJOR}::Core
)

=== examples/basics/CMakeLists.txt ===
add_executable(await-sync-string await-sync-string.cpp)
target_link_libraries(await-sync-string QCoro${QT_VERSION_MAJOR}::Coro)

add_executable(await-async-string await-async-string.cpp)
target_link_libraries(await-async-string QCoro${QT_VERSION_MAJOR}::Coro Qt${QT_VERSION_MAJOR}::Core)

=== examples/network/CMakeLists.txt ===
add_executable(network-example main.cpp)
target_link_libraries(network-example
    QCoro${QT_VERSION_MAJOR}Network
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Widgets
    Qt${QT_VERSION_MAJOR}::Network
)

=== examples/timer/CMakeLists.txt ===
add_executable(timer-example main.cpp)
target_link_libraries(timer-example
    QCoro${QT_VERSION_MAJOR}Core
    Qt${QT_VERSION_MAJOR}::Core
)

=== qcoro/dbus/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021 Daniel Vrátil <dvratil@kde.org>
#
# SPDX-License-Identifier: MIT

add_qcoro_library(
    NAME DBus
    SOURCES
        qcorodbuspendingcall.cpp
    CAMELCASE_HEADERS
        QCoroDBus
        QCoroDBusPendingCall
        QCoroDBusPendingReply
    QCORO_LINK_LIBRARIES
        PUBLIC Coro Core
    QT_LINK_LIBRARIES
        PUBLIC Core DBus
)

=== tests/testlibs/CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,12 @@
-add_library(qcoro_test
+add_library(qcoro_testlib
     STATIC
     testobject.cpp
     testloop.cpp
 )
-target_include_directories(qcoro_test PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
-target_link_libraries(qcoro_test PUBLIC
+target_include_directories(qcoro_testlib PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
+target_link_libraries(qcoro_testlib PUBLIC
     QCoro${QT_VERSION_MAJOR}Core
+    QCoro${QT_VERSION_MAJOR}Test
     Qt${QT_VERSION_MAJOR}::Core
     Qt${QT_VERSION_MAJOR}::Test
 )

=== debian/changelog ===
qcoro (0.11.0-2~build5) plucky; urgency=medium

  * No-change rebuild for Qt 6.8.3 (LP: #2103945).

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sat, 29 Mar 2025 15:11:51 -0500

qcoro (0.11.0-2~build4) plucky; urgency=medium

  * No-change rebuild for Qt 6.8.2.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Tue, 04 Feb 2025 14:13:49 -0600

qcoro (0.11.0-2~build3) plucky; urgency=medium

  * No-change rebuild for Qt 6.8.1.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Wed, 04 Dec 2024 18:59:49 -0600

qcoro (0.11.0-2~build2) plucky; urgency=medium

  * No-change rebuild for Qt 6.8.0.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Wed, 04 Dec 2024 18:59:48 -0600

qcoro (0.11.0-2~build1) plucky; urgency=medium

  [ Pino Toscano ]
  * Run xvfb-run with -a, to avoid potential collisions.

  [ Simon Quigley ]
  * Update symbols from build logs.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Mon, 02 Dec 2024 03:15:32 -0600

qcoro (0.11.0-1) unstable; urgency=medium

  * Team upload.

  [ Patrick Franz ]
  * Use correct package name for qt6-websockets-dev in the dependencies of
    qcoro-qt6-dev.

  [ Pino Toscano ]
  * Update references in debian/upstream/metadata, debian/watch, and
    debian/copyright to the new https://github.com/qcoro/qcoro upstream
    repository.
  * Update Homepage to https://qcoro.dev.
  * New upstream release.
  * Update symbols files.

 -- Pino Toscano <pino@debian.org>  Tue, 05 Nov 2024 06:00:55 +0100

qcoro (0.10.0-3) unstable; urgency=medium

  * Team upload.
  * Update symbols files.
  * Update lintian overrides: remove no more overrides for
    needed package-name-doesnt-match-sonames.

 -- Pino Toscano <pino@debian.org>  Sat, 03 Aug 2024 06:12:09 +0200

qcoro (0.10.0-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.
  * Bump Standards-Version to 4.7.0, no changes required.
  * Update symbols files.

 -- Pino Toscano <pino@debian.org>  Fri, 07 Jun 2024 20:40:29 +0200

qcoro (0.10.0-2~exp1) experimental; urgency=medium

  * Team upload.

  [ Gary Wang ]
  * Catch up qt 6 package name changes

  [ Aurélien COUDERC ]
  * Rebuild against Qt6 version 6.6.2.
  * Update symbols from build for 0.10.0.
  * Refresh lintian overrides.

 -- Aurélien COUDERC <coucouf@debian.org>  Mon, 20 May 2024 16:29:41 +0200

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,13 @@
 Source: qcoro
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
+Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
 Uploaders: Sandro Knauß <hefee@debian.org>
 Build-Depends: dpkg-dev (>= 1.22.5), cmake (>= 3.18.4~),
                dbus-x11 <!nocheck>,
                debhelper-compat (= 13),
                libqt5websockets5-dev (>= 5.15.0~),
-               libqt6opengl6-dev,
-               libqt6websockets6-dev (>= 6.2.0~),
+               qt6-websockets-dev (>= 6.2.0~),
                pkg-kde-tools,
                qml-module-qtquick-controls <!nocheck>,
                qml6-module-qtqml-workerscript <!nocheck>,
@@ -24,10 +22,10 @@
                qtdeclarative5-private-dev,
                xauth <!nocheck>,
                xvfb <!nocheck>
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/qcoro
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/qcoro.git
-Homepage: https://qcoro.dvratil.cz/
+Homepage: https://qcoro.dev
 Rules-Requires-Root: no
 
 Package: libqcoro5core0t64
@@ -226,8 +224,8 @@
          libqcoro6qml0t64 (= ${binary:Version}),
          libqcoro6quick0t64 (= ${binary:Version}),
          libqcoro6websockets0t64 (= ${binary:Version}),
-         libqt6websockets6-dev (>= 6.2.0~),
          qt6-base-dev (>= 6.2.0~),
+         qt6-websockets-dev (>= 6.2.0~),
          ${misc:Depends}
 Recommends: qcoro-doc
 Section: libdevel
